export make_row, make_grid, setindex_

function make_row(columns::Integer)
    #Returns tuple, needs to be Node(:div, tuple..) before use
    style = Dict(:display => "inline-table",
                 :verticalAlign => "top",
                 :width => "$(100/columns)%")
    #:transform => "scale($(1/columns))")
    (Node(:div, style=style, "Lorem Ipsum") for i in 1:columns)
end

function make_grid(rows::Integer, columns::Integer, width = 800, height = 1000)
    style_row  = Dict(:height => "$(100/rows)%", :overflow => "auto")
    style_grid = Dict(:width  => width, :height => height)
    Node(:div, style=style_grid, (Node(:div, style=style_row, make_row(columns)...)
                                 for i in 1:rows)...)
end

#specify this later, should be some sort of typedef of WebIO.Node{WebIO.DOM}


# We give the content of the container if given two arguments
# If given one argument, we give the child
# This means a[r,c] = a[r][c][1] and not a[r][c]
# We to do this to keep the style (width and formatting of the columns)

function Base.getindex(grid::WebIO.Node{WebIO.DOM}, ind::Integer)
    grid.children[ind]
end

function Base.getindex(grid::WebIO.Node{WebIO.DOM}, row::Integer, column::Integer)
    grid[row][column][1]
end



function setindex_(grid::WebIO.Node{WebIO.DOM},
                   new_value,
                  ind::Integer)
    #Make this look nicer
    setchild(grid, ind, setchild(grid[ind], 1, Node(:div, new_value)))
end

function setindex_(grid::WebIO.Node{WebIO.DOM},
                   new_value,
                   row::Integer,
                   column::Integer)
    #Make this look nicer
    setchild(grid, row, setindex_(grid[row], new_value, column))
end		
